import{S as os,i as as,s as ns,e as a,k as d,w as _,t as s,M as rs,c as n,d as o,m as c,a as r,x as g,h as i,b as l,G as t,g as h,y as v,q as b,o as k,B as y,v as ss,L as ts}from"../../chunks/vendor-hf-doc-builder.js";import{T as is}from"../../chunks/Tip-hf-doc-builder.js";import{D as q}from"../../chunks/Docstring-hf-doc-builder.js";import{C as Do}from"../../chunks/CodeBlock-hf-doc-builder.js";import{I as Ke}from"../../chunks/IconCopyLink-hf-doc-builder.js";import{E as es}from"../../chunks/ExampleCodeBlock-hf-doc-builder.js";function ls(J){let p,T;return p=new Do({props:{code:`from transformers import LlamaModel, LlamaConfig

# Initializing a LLaMA llama-7b style configuration
configuration = LlamaConfig()

# Initializing a model from the llama-7b style configuration
model = LlamaModel(configuration)

# Accessing the model configuration
configuration = model.config`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> transformers <span class="hljs-keyword">import</span> LlamaModel, LlamaConfig

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># Initializing a LLaMA llama-7b style configuration</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>configuration = LlamaConfig()

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># Initializing a model from the llama-7b style configuration</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>model = LlamaModel(configuration)

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># Accessing the model configuration</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>configuration = model.config`}}),{c(){_(p.$$.fragment)},l(f){g(p.$$.fragment,f)},m(f,L){v(p,f,L),T=!0},p:ts,i(f){T||(b(p.$$.fragment,f),T=!0)},o(f){k(p.$$.fragment,f),T=!1},d(f){y(p,f)}}}function ds(J){let p,T,f,L,E;return L=new Do({props:{code:`from transformers import AutoTokenizer, LlamaForCausalLM

model = LlamaForCausalLM.from_pretrained(PATH_TO_CONVERTED_WEIGHTS)
tokenizer = AutoTokenizer.from_pretrained(PATH_TO_CONVERTED_TOKENIZER)

prompt = "Hey, are you consciours? Can you talk to me?"
inputs = tokenizer(prompt, return_tensors="pt")

# Generate
generate_ids = model.generate(inputs.input_ids, max_length=30)
tokenizer.batch_decode(generate_ids, skip_special_tokens=True, clean_up_tokenization_spaces=False)[0]`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> transformers <span class="hljs-keyword">import</span> AutoTokenizer, LlamaForCausalLM

<span class="hljs-meta">&gt;&gt;&gt; </span>model = LlamaForCausalLM.from_pretrained(PATH_TO_CONVERTED_WEIGHTS)
<span class="hljs-meta">&gt;&gt;&gt; </span>tokenizer = AutoTokenizer.from_pretrained(PATH_TO_CONVERTED_TOKENIZER)

<span class="hljs-meta">&gt;&gt;&gt; </span>prompt = <span class="hljs-string">&quot;Hey, are you consciours? Can you talk to me?&quot;</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>inputs = tokenizer(prompt, return_tensors=<span class="hljs-string">&quot;pt&quot;</span>)

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># Generate</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>generate_ids = model.generate(inputs.input_ids, max_length=<span class="hljs-number">30</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>tokenizer.batch_decode(generate_ids, skip_special_tokens=<span class="hljs-literal">True</span>, clean_up_tokenization_spaces=<span class="hljs-literal">False</span>)[<span class="hljs-number">0</span>]
<span class="hljs-string">&quot;Hey, are you consciours? Can you talk to me?\\nI&#x27;m not consciours, but I can talk to you.&quot;</span>`}}),{c(){p=a("p"),T=s("Example:"),f=d(),_(L.$$.fragment)},l(u){p=n(u,"P",{});var $=r(p);T=i($,"Example:"),$.forEach(o),f=c(u),g(L.$$.fragment,u)},m(u,$){h(u,p,$),t(p,T),h(u,f,$),v(L,u,$),E=!0},p:ts,i(u){E||(b(L.$$.fragment,u),E=!0)},o(u){k(L.$$.fragment,u),E=!1},d(u){u&&o(p),u&&o(f),y(L,u)}}}function cs(J){let p,T,f,L,E;return{c(){p=a("p"),T=s("Although the recipe for forward pass needs to be defined within this function, one should call the "),f=a("code"),L=s("Module"),E=s(`
instance afterwards instead of this since the former takes care of running the pre and post processing steps while
the latter silently ignores them.`)},l(u){p=n(u,"P",{});var $=r(p);T=i($,"Although the recipe for forward pass needs to be defined within this function, one should call the "),f=n($,"CODE",{});var K=r(f);L=i(K,"Module"),K.forEach(o),E=i($,`
instance afterwards instead of this since the former takes care of running the pre and post processing steps while
the latter silently ignores them.`),$.forEach(o)},m(u,$){h(u,p,$),t(p,T),t(p,f),t(f,L),t(p,E)},d(u){u&&o(p)}}}function ms(J){let p,T,f,L,E,u,$,K,Bo,Kt,B,Z,bt,fe,jo,kt,Wo,Zt,Ze,Ho,Qt,Qe,Go,Yt,Ye,yt,Ro,eo,et,Vo,to,Q,tt,Uo,ue,Xo,Jo,_e,Ko,ot,Zo,Qo,oo,ge,ao,at,Lt,Yo,no,ve,ro,nt,ea,so,rt,I,ta,be,oa,aa,wt,na,ra,Tt,sa,ia,io,C,la,ke,da,ca,ye,ma,ha,Le,pa,fa,we,ua,_a,lo,j,Y,$t,Te,ga,zt,va,co,A,$e,ba,ze,ka,st,ya,La,wa,W,Ta,it,$a,za,lt,Ma,Ea,Ca,ee,mo,H,te,Mt,Me,xa,Et,Aa,ho,z,Ee,Pa,Ct,Fa,qa,dt,Ce,Ia,oe,xe,Oa,Ae,Sa,xt,Na,Da,Ba,ae,Pe,ja,At,Wa,Ha,ne,Fe,Ga,Pt,Ra,po,G,re,Ft,qe,Va,qt,Ua,fo,M,Ie,Xa,Oe,Ja,ct,Ka,Za,Qa,Se,Ya,Ne,en,tn,on,se,an,It,nn,rn,Ot,sn,ln,mt,De,uo,R,ie,St,Be,dn,Nt,cn,_o,V,je,mn,le,We,hn,de,go,U,ce,Dt,He,pn,Bt,fn,vo,w,Ge,un,jt,_n,gn,ht,pt,vn,bn,kn,P,yn,Wt,Ln,wn,Ht,Tn,$n,Gt,zn,Mn,Rt,En,Cn,xn,Re,An,ft,Pn,Fn,qn,Ve,In,Ue,On,Sn,Nn,O,Xe,Dn,X,Bn,ut,jn,Wn,Vt,Hn,Gn,Rn,me,bo;return u=new Ke({}),fe=new Ke({}),ge=new Do({props:{code:`python src/transformers/models/llama/convert_llama_weights_to_hf.py \\
    --input_dir /path/to/downloaded/llama/weights --model_size 7B --output_dir /output/path`,highlighted:`python src/transformers/models/llama/convert_llama_weights_to_hf.py \\
    --input_dir /path/to/downloaded/llama/weights --model_size 7B --output_dir /output/path`}}),ve=new Do({props:{code:`from transformers import LlamaForCausalLM, LlamaTokenizer

tokenizer = LlamaTokenizer.from_pretrained("/output/path")
model = LlamaForCausalLM.from_pretrained("/output/path")`,highlighted:`<span class="hljs-keyword">from</span> transformers <span class="hljs-keyword">import</span> LlamaForCausalLM, LlamaTokenizer

tokenizer = LlamaTokenizer.from_pretrained(<span class="hljs-string">&quot;/output/path&quot;</span>)
model = LlamaForCausalLM.from_pretrained(<span class="hljs-string">&quot;/output/path&quot;</span>)`}}),Te=new Ke({}),$e=new q({props:{name:"class transformers.LlamaConfig",anchor:"transformers.LlamaConfig",parameters:[{name:"vocab_size",val:" = 32000"},{name:"hidden_size",val:" = 4096"},{name:"intermediate_size",val:" = 11008"},{name:"num_hidden_layers",val:" = 32"},{name:"num_attention_heads",val:" = 32"},{name:"hidden_act",val:" = 'silu'"},{name:"initializer_range",val:" = 0.02"},{name:"rms_norm_eps",val:" = 1e-06"},{name:"use_cache",val:" = True"},{name:"pad_token_id",val:" = 0"},{name:"bos_token_id",val:" = 1"},{name:"eos_token_id",val:" = 2"},{name:"tie_word_embeddings",val:" = False"},{name:"**kwargs",val:""}],parametersDescription:[{anchor:"transformers.LlamaConfig.vocab_size",description:`<strong>vocab_size</strong> (<code>int</code>, <em>optional</em>, defaults to 32000) &#x2014;
Vocabulary size of the LLaMA model. Defines the number of different tokens that can be represented by the
<code>inputs_ids</code> passed when calling <a href="/docs/transformers/pr_22317/en/model_doc/llama#transformers.LlamaModel">LlamaModel</a>`,name:"vocab_size"},{anchor:"transformers.LlamaConfig.hidden_size",description:`<strong>hidden_size</strong> (<code>int</code>, <em>optional</em>, defaults to 4096) &#x2014;
Dimension of the hidden representations.`,name:"hidden_size"},{anchor:"transformers.LlamaConfig.intermediate_size",description:`<strong>intermediate_size</strong> (<code>int</code>, <em>optional</em>, defaults to 11008) &#x2014;
Dimension of the MLP representations.`,name:"intermediate_size"},{anchor:"transformers.LlamaConfig.num_hidden_layers",description:`<strong>num_hidden_layers</strong> (<code>int</code>, <em>optional</em>, defaults to 32) &#x2014;
Number of hidden layers in the Transformer encoder.`,name:"num_hidden_layers"},{anchor:"transformers.LlamaConfig.num_attention_heads",description:`<strong>num_attention_heads</strong> (<code>int</code>, <em>optional</em>, defaults to 32) &#x2014;
Number of attention heads for each attention layer in the Transformer encoder.`,name:"num_attention_heads"},{anchor:"transformers.LlamaConfig.hidden_act",description:`<strong>hidden_act</strong> (<code>str</code> or <code>function</code>, <em>optional</em>, defaults to <code>&quot;silu&quot;</code>) &#x2014;
The non-linear activation function (function or string) in the decoder.`,name:"hidden_act"},{anchor:"transformers.LlamaConfig.initializer_range",description:`<strong>initializer_range</strong> (<code>float</code>, <em>optional</em>, defaults to 0.02) &#x2014;
The standard deviation of the truncated_normal_initializer for initializing all weight matrices.`,name:"initializer_range"},{anchor:"transformers.LlamaConfig.rms_norm_eps",description:`<strong>rms_norm_eps</strong> (<code>float</code>, <em>optional</em>, defaults to 1e-12) &#x2014;
The epsilon used by the rms normalization layers.`,name:"rms_norm_eps"},{anchor:"transformers.LlamaConfig.use_cache",description:`<strong>use_cache</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>True</code>) &#x2014;
Whether or not the model should return the last key/values attentions (not used by all models). Only
relevant if <code>config.is_decoder=True</code>.`,name:"use_cache"},{anchor:"transformers.LlamaConfig.tie_word_embeddings(bool,",description:`<strong>tie_word_embeddings(<code>bool</code>,</strong> <em>optional</em>, defaults to <code>False</code>) &#x2014;
Whether to tie weight embeddings
Example &#x2014;`,name:"tie_word_embeddings(bool,"}],source:"https://github.com/huggingface/transformers/blob/vr_22317/src/transformers/models/llama/configuration_llama.py#L31"}}),ee=new es({props:{anchor:"transformers.LlamaConfig.example",$$slots:{default:[ls]},$$scope:{ctx:J}}}),Me=new Ke({}),Ee=new q({props:{name:"class transformers.LlamaTokenizer",anchor:"transformers.LlamaTokenizer",parameters:[{name:"vocab_file",val:""},{name:"unk_token",val:" = '<unk>'"},{name:"bos_token",val:" = '<s>'"},{name:"eos_token",val:" = '</s>'"},{name:"sp_model_kwargs",val:": typing.Union[typing.Dict[str, typing.Any], NoneType] = None"},{name:"add_bos_token",val:" = True"},{name:"add_eos_token",val:" = False"},{name:"decode_with_prefix_space",val:" = False"},{name:"**kwargs",val:""}],parametersDescription:[{anchor:"transformers.LlamaTokenizer.vocab_file",description:`<strong>vocab_file</strong> (<code>str</code>) &#x2014;
Path to the vocabulary file.`,name:"vocab_file"}],source:"https://github.com/huggingface/transformers/blob/vr_22317/src/transformers/models/llama/tokenization_llama.py#L39"}}),Ce=new q({props:{name:"build_inputs_with_special_tokens",anchor:"transformers.LlamaTokenizer.build_inputs_with_special_tokens",parameters:[{name:"token_ids_0",val:""},{name:"token_ids_1",val:" = None"}],source:"https://github.com/huggingface/transformers/blob/vr_22317/src/transformers/models/llama/tokenization_llama.py#L168"}}),xe=new q({props:{name:"get_special_tokens_mask",anchor:"transformers.LlamaTokenizer.get_special_tokens_mask",parameters:[{name:"token_ids_0",val:": typing.List[int]"},{name:"token_ids_1",val:": typing.Optional[typing.List[int]] = None"},{name:"already_has_special_tokens",val:": bool = False"}],parametersDescription:[{anchor:"transformers.LlamaTokenizer.get_special_tokens_mask.token_ids_0",description:`<strong>token_ids_0</strong> (<code>List[int]</code>) &#x2014;
List of IDs.`,name:"token_ids_0"},{anchor:"transformers.LlamaTokenizer.get_special_tokens_mask.token_ids_1",description:`<strong>token_ids_1</strong> (<code>List[int]</code>, <em>optional</em>) &#x2014;
Optional second list of IDs for sequence pairs.`,name:"token_ids_1"},{anchor:"transformers.LlamaTokenizer.get_special_tokens_mask.already_has_special_tokens",description:`<strong>already_has_special_tokens</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>False</code>) &#x2014;
Whether or not the token list is already formatted with special tokens for the model.`,name:"already_has_special_tokens"}],source:"https://github.com/huggingface/transformers/blob/vr_22317/src/transformers/models/llama/tokenization_llama.py#L184",returnDescription:`
<p>A list of integers in the range [0, 1]: 1 for a special token, 0 for a sequence token.</p>
`,returnType:`
<p><code>List[int]</code></p>
`}}),Pe=new q({props:{name:"create_token_type_ids_from_sequences",anchor:"transformers.LlamaTokenizer.create_token_type_ids_from_sequences",parameters:[{name:"token_ids_0",val:": typing.List[int]"},{name:"token_ids_1",val:": typing.Optional[typing.List[int]] = None"}],parametersDescription:[{anchor:"transformers.LlamaTokenizer.create_token_type_ids_from_sequences.token_ids_0",description:`<strong>token_ids_0</strong> (<code>List[int]</code>) &#x2014;
List of IDs.`,name:"token_ids_0"},{anchor:"transformers.LlamaTokenizer.create_token_type_ids_from_sequences.token_ids_1",description:`<strong>token_ids_1</strong> (<code>List[int]</code>, <em>optional</em>) &#x2014;
Optional second list of IDs for sequence pairs.`,name:"token_ids_1"}],source:"https://github.com/huggingface/transformers/blob/vr_22317/src/transformers/models/llama/tokenization_llama.py#L211",returnDescription:`
<p>List of zeros.</p>
`,returnType:`
<p><code>List[int]</code></p>
`}}),Fe=new q({props:{name:"save_vocabulary",anchor:"transformers.LlamaTokenizer.save_vocabulary",parameters:[{name:"save_directory",val:""},{name:"filename_prefix",val:": typing.Optional[str] = None"}],parametersDescription:[{anchor:"transformers.LlamaTokenizer.save_vocabulary.save_directory",description:`<strong>save_directory</strong> (<code>str</code>) &#x2014;
The directory in which to save the vocabulary.`,name:"save_directory"}],source:"https://github.com/huggingface/transformers/blob/vr_22317/src/transformers/models/llama/tokenization_llama.py#L141",returnDescription:`
<p>Paths to the files saved.</p>
`,returnType:`
<p><code>Tuple(str)</code></p>
`}}),qe=new Ke({}),Ie=new q({props:{name:"class transformers.LlamaModel",anchor:"transformers.LlamaModel",parameters:[{name:"config",val:": LlamaConfig"}],parametersDescription:[{anchor:"transformers.LlamaModel.config",description:`<strong>config</strong> (<a href="/docs/transformers/pr_22317/en/model_doc/llama#transformers.LlamaConfig">LlamaConfig</a>) &#x2014;
Model configuration class with all the parameters of the model. Initializing with a config file does not
load the weights associated with the model, only the configuration. Check out the
<a href="/docs/transformers/pr_22317/en/main_classes/model#transformers.PreTrainedModel.from_pretrained">from_pretrained()</a> method to load the model weights.
config &#x2014; LlamaConfig`,name:"config"}],source:"https://github.com/huggingface/transformers/blob/vr_22317/src/transformers/models/llama/modeling_llama.py#L443"}}),De=new q({props:{name:"forward",anchor:"transformers.LlamaModel.forward",parameters:[{name:"input_ids",val:": LongTensor = None"},{name:"attention_mask",val:": typing.Optional[torch.Tensor] = None"},{name:"past_key_values",val:": typing.Optional[typing.List[torch.FloatTensor]] = None"},{name:"inputs_embeds",val:": typing.Optional[torch.FloatTensor] = None"},{name:"use_cache",val:": typing.Optional[bool] = None"},{name:"output_attentions",val:": typing.Optional[bool] = None"},{name:"output_hidden_states",val:": typing.Optional[bool] = None"},{name:"return_dict",val:": typing.Optional[bool] = None"}],parametersDescription:[{anchor:"transformers.LlamaModel.forward.input_ids",description:`<strong>input_ids</strong> (<code>torch.LongTensor</code> of shape <code>(batch_size, sequence_length)</code>) &#x2014;
Indices of input sequence tokens in the vocabulary. Padding will be ignored by default should you
provide it.</p>
<p>Indices can be obtained using <a href="/docs/transformers/pr_22317/en/model_doc/auto#transformers.AutoTokenizer">AutoTokenizer</a>. See <a href="/docs/transformers/pr_22317/en/internal/tokenization_utils#transformers.PreTrainedTokenizerBase.encode">PreTrainedTokenizer.encode()</a> and
<a href="/docs/transformers/pr_22317/en/internal/tokenization_utils#transformers.PreTrainedTokenizerBase.__call__">PreTrainedTokenizer.<strong>call</strong>()</a> for details.</p>
<p><a href="../glossary#input-ids">What are input IDs?</a>`,name:"input_ids"},{anchor:"transformers.LlamaModel.forward.attention_mask",description:`<strong>attention_mask</strong> (<code>torch.Tensor</code> of shape <code>(batch_size, sequence_length)</code>, <em>optional</em>) &#x2014;
Mask to avoid performing attention on padding token indices. Mask values selected in <code>[0, 1]</code>:</p>
<ul>
<li>1 for tokens that are <strong>not masked</strong>,</li>
<li>0 for tokens that are <strong>masked</strong>.</li>
</ul>
<p><a href="../glossary#attention-mask">What are attention masks?</a>`,name:"attention_mask"},{anchor:"transformers.LlamaModel.forward.past_key_values",description:`<strong>past_key_values</strong> (<code>tuple(tuple(torch.FloatTensor))</code>, <em>optional</em>, returned when <code>use_cache=True</code> is passed or when <code>config.use_cache=True</code>) &#x2014;
Tuple of <code>tuple(torch.FloatTensor)</code> of length <code>config.n_layers</code>, with each tuple having 2 tensors of
shape <code>(batch_size, num_heads, sequence_length, embed_size_per_head)</code>) and 2 additional tensors of</p>
<p>Contains pre-computed hidden-states (key and values in the self-attention blocks and in the
cross-attention blocks) that can be used (see <code>past_key_values</code> input) to speed up sequential decoding.</p>
<p>If <code>past_key_values</code> are used, the user can optionally input only the last <code>decoder_input_ids</code> (those
that don&#x2019;t have their past key value states given to this model) of shape <code>(batch_size, 1)</code> instead of
all <code>decoder_input_ids</code> of shape <code>(batch_size, sequence_length)</code>.`,name:"past_key_values"},{anchor:"transformers.LlamaModel.forward.use_cache",description:`<strong>use_cache</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
If set to <code>True</code>, <code>past_key_values</code> key value states are returned and can be used to speed up decoding
(see <code>past_key_values</code>).`,name:"use_cache"},{anchor:"transformers.LlamaModel.forward.inputs_embeds",description:`<strong>inputs_embeds</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, sequence_length, hidden_size)</code>, <em>optional</em>) &#x2014;
Optionally, instead of passing <code>input_ids</code> you can choose to directly pass an embedded representation.
This is useful if you want more control over how to convert <code>input_ids</code> indices into associated vectors
than the model&#x2019;s internal embedding lookup matrix.`,name:"inputs_embeds"},{anchor:"transformers.LlamaModel.forward.output_attentions",description:`<strong>output_attentions</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return the attentions tensors of all attention layers. See <code>attentions</code> under
returned tensors for more detail.`,name:"output_attentions"},{anchor:"transformers.LlamaModel.forward.output_hidden_states",description:`<strong>output_hidden_states</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return the hidden states of all layers. See <code>hidden_states</code> under returned tensors
for more detail.`,name:"output_hidden_states"},{anchor:"transformers.LlamaModel.forward.return_dict",description:`<strong>return_dict</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return a <a href="/docs/transformers/pr_22317/en/main_classes/output#transformers.utils.ModelOutput">ModelOutput</a> instead of a plain tuple.`,name:"return_dict"}],source:"https://github.com/huggingface/transformers/blob/vr_22317/src/transformers/models/llama/modeling_llama.py#L491"}}),Be=new Ke({}),je=new q({props:{name:"class transformers.LlamaForCausalLM",anchor:"transformers.LlamaForCausalLM",parameters:[{name:"config",val:""}],source:"https://github.com/huggingface/transformers/blob/vr_22317/src/transformers/models/llama/modeling_llama.py#L647"}}),We=new q({props:{name:"forward",anchor:"transformers.LlamaForCausalLM.forward",parameters:[{name:"input_ids",val:": LongTensor = None"},{name:"attention_mask",val:": typing.Optional[torch.Tensor] = None"},{name:"past_key_values",val:": typing.Optional[typing.List[torch.FloatTensor]] = None"},{name:"inputs_embeds",val:": typing.Optional[torch.FloatTensor] = None"},{name:"labels",val:": typing.Optional[torch.LongTensor] = None"},{name:"use_cache",val:": typing.Optional[bool] = None"},{name:"output_attentions",val:": typing.Optional[bool] = None"},{name:"output_hidden_states",val:": typing.Optional[bool] = None"},{name:"return_dict",val:": typing.Optional[bool] = None"}],parametersDescription:[{anchor:"transformers.LlamaForCausalLM.forward.input_ids",description:`<strong>input_ids</strong> (<code>torch.LongTensor</code> of shape <code>(batch_size, sequence_length)</code>) &#x2014;
Indices of input sequence tokens in the vocabulary. Padding will be ignored by default should you
provide it.</p>
<p>Indices can be obtained using <a href="/docs/transformers/pr_22317/en/model_doc/auto#transformers.AutoTokenizer">AutoTokenizer</a>. See <a href="/docs/transformers/pr_22317/en/internal/tokenization_utils#transformers.PreTrainedTokenizerBase.encode">PreTrainedTokenizer.encode()</a> and
<a href="/docs/transformers/pr_22317/en/internal/tokenization_utils#transformers.PreTrainedTokenizerBase.__call__">PreTrainedTokenizer.<strong>call</strong>()</a> for details.</p>
<p><a href="../glossary#input-ids">What are input IDs?</a>`,name:"input_ids"},{anchor:"transformers.LlamaForCausalLM.forward.attention_mask",description:`<strong>attention_mask</strong> (<code>torch.Tensor</code> of shape <code>(batch_size, sequence_length)</code>, <em>optional</em>) &#x2014;
Mask to avoid performing attention on padding token indices. Mask values selected in <code>[0, 1]</code>:</p>
<ul>
<li>1 for tokens that are <strong>not masked</strong>,</li>
<li>0 for tokens that are <strong>masked</strong>.</li>
</ul>
<p><a href="../glossary#attention-mask">What are attention masks?</a>`,name:"attention_mask"},{anchor:"transformers.LlamaForCausalLM.forward.past_key_values",description:`<strong>past_key_values</strong> (<code>tuple(tuple(torch.FloatTensor))</code>, <em>optional</em>, returned when <code>use_cache=True</code> is passed or when <code>config.use_cache=True</code>) &#x2014;
Tuple of <code>tuple(torch.FloatTensor)</code> of length <code>config.n_layers</code>, with each tuple having 2 tensors of
shape <code>(batch_size, num_heads, sequence_length, embed_size_per_head)</code>) and 2 additional tensors of
shape <code>(batch_size, num_heads, encoder_sequence_length, embed_size_per_head)</code>. The two additional
tensors are only required when the model is used as a decoder in a Sequence to Sequence model.</p>
<p>Contains pre-computed hidden-states (key and values in the self-attention blocks and in the
cross-attention blocks) that can be used (see <code>past_key_values</code> input) to speed up sequential decoding.</p>
<p>If <code>past_key_values</code> are used, the user can optionally input only the last <code>decoder_input_ids</code> (those
that don&#x2019;t have their past key value states given to this model) of shape <code>(batch_size, 1)</code> instead of
all <code>decoder_input_ids</code> of shape <code>(batch_size, sequence_length)</code>.`,name:"past_key_values"},{anchor:"transformers.LlamaForCausalLM.forward.inputs_embeds",description:`<strong>inputs_embeds</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, sequence_length, hidden_size)</code>, <em>optional</em>) &#x2014;
Optionally, instead of passing <code>input_ids</code> you can choose to directly pass an embedded representation.
This is useful if you want more control over how to convert <code>input_ids</code> indices into associated vectors
than the model&#x2019;s internal embedding lookup matrix.`,name:"inputs_embeds"},{anchor:"transformers.LlamaForCausalLM.forward.labels",description:`<strong>labels</strong> (<code>torch.LongTensor</code> of shape <code>(batch_size, sequence_length)</code>, <em>optional</em>) &#x2014;
Labels for computing the masked language modeling loss. Indices should either be in <code>[0, ..., config.vocab_size]</code> or -100 (see <code>input_ids</code> docstring). Tokens with indices set to <code>-100</code> are ignored
(masked), the loss is only computed for the tokens with labels in <code>[0, ..., config.vocab_size]</code>.`,name:"labels"},{anchor:"transformers.LlamaForCausalLM.forward.use_cache",description:`<strong>use_cache</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
If set to <code>True</code>, <code>past_key_values</code> key value states are returned and can be used to speed up decoding
(see <code>past_key_values</code>).`,name:"use_cache"},{anchor:"transformers.LlamaForCausalLM.forward.output_attentions",description:`<strong>output_attentions</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return the attentions tensors of all attention layers. See <code>attentions</code> under
returned tensors for more detail.`,name:"output_attentions"},{anchor:"transformers.LlamaForCausalLM.forward.output_hidden_states",description:`<strong>output_hidden_states</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return the hidden states of all layers. See <code>hidden_states</code> under returned tensors
for more detail.`,name:"output_hidden_states"},{anchor:"transformers.LlamaForCausalLM.forward.return_dict",description:`<strong>return_dict</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return a <a href="/docs/transformers/pr_22317/en/main_classes/output#transformers.utils.ModelOutput">ModelOutput</a> instead of a plain tuple.`,name:"return_dict"}],source:"https://github.com/huggingface/transformers/blob/vr_22317/src/transformers/models/llama/modeling_llama.py#L677",returnDescription:`
<p>A <a
  href="/docs/transformers/pr_22317/en/main_classes/output#transformers.modeling_outputs.CausalLMOutputWithPast"
>transformers.modeling_outputs.CausalLMOutputWithPast</a> or a tuple of
<code>torch.FloatTensor</code> (if <code>return_dict=False</code> is passed or when <code>config.return_dict=False</code>) comprising various
elements depending on the configuration (<a
  href="/docs/transformers/pr_22317/en/model_doc/llama#transformers.LlamaConfig"
>LlamaConfig</a>) and inputs.</p>
<ul>
<li>
<p><strong>loss</strong> (<code>torch.FloatTensor</code> of shape <code>(1,)</code>, <em>optional</em>, returned when <code>labels</code> is provided) \u2014 Language modeling loss (for next-token prediction).</p>
</li>
<li>
<p><strong>logits</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, sequence_length, config.vocab_size)</code>) \u2014 Prediction scores of the language modeling head (scores for each vocabulary token before SoftMax).</p>
</li>
<li>
<p><strong>past_key_values</strong> (<code>tuple(tuple(torch.FloatTensor))</code>, <em>optional</em>, returned when <code>use_cache=True</code> is passed or when <code>config.use_cache=True</code>) \u2014 Tuple of <code>tuple(torch.FloatTensor)</code> of length <code>config.n_layers</code>, with each tuple having 2 tensors of shape
<code>(batch_size, num_heads, sequence_length, embed_size_per_head)</code>)</p>
<p>Contains pre-computed hidden-states (key and values in the self-attention blocks) that can be used (see
<code>past_key_values</code> input) to speed up sequential decoding.</p>
</li>
<li>
<p><strong>hidden_states</strong> (<code>tuple(torch.FloatTensor)</code>, <em>optional</em>, returned when <code>output_hidden_states=True</code> is passed or when <code>config.output_hidden_states=True</code>) \u2014 Tuple of <code>torch.FloatTensor</code> (one for the output of the embeddings, if the model has an embedding layer, +
one for the output of each layer) of shape <code>(batch_size, sequence_length, hidden_size)</code>.</p>
<p>Hidden-states of the model at the output of each layer plus the optional initial embedding outputs.</p>
</li>
<li>
<p><strong>attentions</strong> (<code>tuple(torch.FloatTensor)</code>, <em>optional</em>, returned when <code>output_attentions=True</code> is passed or when <code>config.output_attentions=True</code>) \u2014 Tuple of <code>torch.FloatTensor</code> (one for each layer) of shape <code>(batch_size, num_heads, sequence_length, sequence_length)</code>.</p>
<p>Attentions weights after the attention softmax, used to compute the weighted average in the self-attention
heads.</p>
</li>
</ul>
`,returnType:`
<p><a
  href="/docs/transformers/pr_22317/en/main_classes/output#transformers.modeling_outputs.CausalLMOutputWithPast"
>transformers.modeling_outputs.CausalLMOutputWithPast</a> or <code>tuple(torch.FloatTensor)</code></p>
`}}),de=new es({props:{anchor:"transformers.LlamaForCausalLM.forward.example",$$slots:{default:[ds]},$$scope:{ctx:J}}}),He=new Ke({}),Ge=new q({props:{name:"class transformers.LlamaForSequenceClassification",anchor:"transformers.LlamaForSequenceClassification",parameters:[{name:"config",val:""}],parametersDescription:[{anchor:"transformers.LlamaForSequenceClassification.config",description:`<strong>config</strong> (<a href="/docs/transformers/pr_22317/en/model_doc/llama#transformers.LlamaConfig">LlamaConfig</a>) &#x2014;
Model configuration class with all the parameters of the model. Initializing with a config file does not
load the weights associated with the model, only the configuration. Check out the
<a href="/docs/transformers/pr_22317/en/main_classes/model#transformers.PreTrainedModel.from_pretrained">from_pretrained()</a> method to load the model weights.`,name:"config"}],source:"https://github.com/huggingface/transformers/blob/vr_22317/src/transformers/models/llama/modeling_llama.py#L844"}}),Xe=new q({props:{name:"forward",anchor:"transformers.LlamaForSequenceClassification.forward",parameters:[{name:"input_ids",val:": LongTensor = None"},{name:"attention_mask",val:": typing.Optional[torch.Tensor] = None"},{name:"past_key_values",val:": typing.Optional[typing.List[torch.FloatTensor]] = None"},{name:"inputs_embeds",val:": typing.Optional[torch.FloatTensor] = None"},{name:"labels",val:": typing.Optional[torch.LongTensor] = None"},{name:"use_cache",val:": typing.Optional[bool] = None"},{name:"output_attentions",val:": typing.Optional[bool] = None"},{name:"output_hidden_states",val:": typing.Optional[bool] = None"},{name:"return_dict",val:": typing.Optional[bool] = None"}],parametersDescription:[{anchor:"transformers.LlamaForSequenceClassification.forward.input_ids",description:`<strong>input_ids</strong> (<code>torch.LongTensor</code> of shape <code>(batch_size, sequence_length)</code>) &#x2014;
Indices of input sequence tokens in the vocabulary. Padding will be ignored by default should you provide
it.</p>
<p>Indices can be obtained using <a href="/docs/transformers/pr_22317/en/model_doc/auto#transformers.AutoTokenizer">AutoTokenizer</a>. See <a href="/docs/transformers/pr_22317/en/internal/tokenization_utils#transformers.PreTrainedTokenizerBase.encode">PreTrainedTokenizer.encode()</a> and
<a href="/docs/transformers/pr_22317/en/internal/tokenization_utils#transformers.PreTrainedTokenizerBase.__call__">PreTrainedTokenizer.<strong>call</strong>()</a> for details.</p>
<p><a href="../glossary#input-ids">What are input IDs?</a>`,name:"input_ids"},{anchor:"transformers.LlamaForSequenceClassification.forward.attention_mask",description:`<strong>attention_mask</strong> (<code>torch.Tensor</code> of shape <code>(batch_size, sequence_length)</code>, <em>optional</em>) &#x2014;
Mask to avoid performing attention on padding token indices. Mask values selected in <code>[0, 1]</code>:</p>
<ul>
<li>1 for tokens that are <strong>not masked</strong>,</li>
<li>0 for tokens that are <strong>masked</strong>.</li>
</ul>
<p><a href="../glossary#attention-mask">What are attention masks?</a></p>
<p>Indices can be obtained using <a href="/docs/transformers/pr_22317/en/model_doc/auto#transformers.AutoTokenizer">AutoTokenizer</a>. See <a href="/docs/transformers/pr_22317/en/internal/tokenization_utils#transformers.PreTrainedTokenizerBase.encode">PreTrainedTokenizer.encode()</a> and
<a href="/docs/transformers/pr_22317/en/internal/tokenization_utils#transformers.PreTrainedTokenizerBase.__call__">PreTrainedTokenizer.<strong>call</strong>()</a> for details.</p>
<p>If <code>past_key_values</code> is used, optionally only the last <code>decoder_input_ids</code> have to be input (see
<code>past_key_values</code>).</p>
<p>If you want to change padding behavior, you should read <code>modeling_opt._prepare_decoder_attention_mask</code>
and modify to your needs. See diagram 1 in <a href="https://arxiv.org/abs/1910.13461" rel="nofollow">the paper</a> for more
information on the default strategy.</p>
<ul>
<li>1 indicates the head is <strong>not masked</strong>,</li>
<li>0 indicates the head is <strong>masked</strong>.</li>
</ul>`,name:"attention_mask"},{anchor:"transformers.LlamaForSequenceClassification.forward.past_key_values",description:`<strong>past_key_values</strong> (<code>tuple(tuple(torch.FloatTensor))</code>, <em>optional</em>, returned when <code>use_cache=True</code> is passed or when <code>config.use_cache=True</code>) &#x2014;
Tuple of <code>tuple(torch.FloatTensor)</code> of length <code>config.n_layers</code>, with each tuple having 2 tensors of shape
<code>(batch_size, num_heads, sequence_length, embed_size_per_head)</code>) and 2 additional tensors of shape
<code>(batch_size, num_heads, encoder_sequence_length, embed_size_per_head)</code>.</p>
<p>Contains pre-computed hidden-states (key and values in the self-attention blocks and in the cross-attention
blocks) that can be used (see <code>past_key_values</code> input) to speed up sequential decoding.</p>
<p>If <code>past_key_values</code> are used, the user can optionally input only the last <code>decoder_input_ids</code> (those that
don&#x2019;t have their past key value states given to this model) of shape <code>(batch_size, 1)</code> instead of all
<code>decoder_input_ids</code> of shape <code>(batch_size, sequence_length)</code>.`,name:"past_key_values"},{anchor:"transformers.LlamaForSequenceClassification.forward.inputs_embeds",description:`<strong>inputs_embeds</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, sequence_length, hidden_size)</code>, <em>optional</em>) &#x2014;
Optionally, instead of passing <code>input_ids</code> you can choose to directly pass an embedded representation. This
is useful if you want more control over how to convert <code>input_ids</code> indices into associated vectors than the
model&#x2019;s internal embedding lookup matrix.`,name:"inputs_embeds"},{anchor:"transformers.LlamaForSequenceClassification.forward.use_cache",description:`<strong>use_cache</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
If set to <code>True</code>, <code>past_key_values</code> key value states are returned and can be used to speed up decoding (see
<code>past_key_values</code>).`,name:"use_cache"},{anchor:"transformers.LlamaForSequenceClassification.forward.output_attentions",description:`<strong>output_attentions</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return the attentions tensors of all attention layers. See <code>attentions</code> under returned
tensors for more detail.`,name:"output_attentions"},{anchor:"transformers.LlamaForSequenceClassification.forward.output_hidden_states",description:`<strong>output_hidden_states</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return the hidden states of all layers. See <code>hidden_states</code> under returned tensors for
more detail.`,name:"output_hidden_states"},{anchor:"transformers.LlamaForSequenceClassification.forward.return_dict",description:`<strong>return_dict</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return a <a href="/docs/transformers/pr_22317/en/main_classes/output#transformers.utils.ModelOutput">ModelOutput</a> instead of a plain tuple.`,name:"return_dict"},{anchor:"transformers.LlamaForSequenceClassification.forward.labels",description:`<strong>labels</strong> (<code>torch.LongTensor</code> of shape <code>(batch_size,)</code>, <em>optional</em>) &#x2014;
Labels for computing the sequence classification/regression loss. Indices should be in <code>[0, ..., config.num_labels - 1]</code>. If <code>config.num_labels == 1</code> a regression loss is computed (Mean-Square loss), If
<code>config.num_labels &gt; 1</code> a classification loss is computed (Cross-Entropy).`,name:"labels"}],source:"https://github.com/huggingface/transformers/blob/vr_22317/src/transformers/models/llama/modeling_llama.py#L862"}}),me=new is({props:{$$slots:{default:[cs]},$$scope:{ctx:J}}}),{c(){p=a("meta"),T=d(),f=a("h1"),L=a("a"),E=a("span"),_(u.$$.fragment),$=d(),K=a("span"),Bo=s("LLaMA"),Kt=d(),B=a("h2"),Z=a("a"),bt=a("span"),_(fe.$$.fragment),jo=d(),kt=a("span"),Wo=s("Overview"),Zt=d(),Ze=a("p"),Ho=s("The LLaMA model was proposed in [LLaMA: Open and Efficient Foundation Language Models](LLaMA: Open and Efficient Foundation Language Models)  by Hugo Touvron, Thibaut Lavril, Gautier Izacard, Xavier Martinet, Marie-Anne Lachaux, Timoth\xE9e Lacroix, Baptiste Rozi\xE8re, Naman Goyal, Eric Hambro, Faisal Azhar, Aurelien Rodriguez, Armand Joulin, Edouard Grave, Guillaume Lample. It is a collection of foundation language models ranging from 7B to 65B parameters."),Qt=d(),Qe=a("p"),Go=s("The abstract from the paper is the following:"),Yt=d(),Ye=a("p"),yt=a("em"),Ro=s("We introduce LLaMA, a collection of foundation language models ranging from 7B to 65B parameters. We train our models on trillions of tokens, and show that it is possible to train state-of-the-art models using publicly available datasets exclusively, without resorting to proprietary and inaccessible datasets. In particular, LLaMA-13B outperforms GPT-3 (175B) on most benchmarks, and LLaMA-65B is competitive with the best models, Chinchilla-70B and PaLM-540B. We release all our models to the research community."),eo=d(),et=a("p"),Vo=s("Tips:"),to=d(),Q=a("ul"),tt=a("li"),Uo=s("Weights for the LLaMA models can be obtained from by filling out "),ue=a("a"),Xo=s("this form"),Jo=d(),_e=a("li"),Ko=s("After downloading the weights, they will need to be converted to the Hugging Face Transformers format using the "),ot=a("a"),Zo=s("conversion script"),Qo=s(". The script can be called with the following (example) command:"),oo=d(),_(ge.$$.fragment),ao=d(),at=a("ul"),Lt=a("li"),Yo=s("After conversion, the model and tokenizer can be loaded via:"),no=d(),_(ve.$$.fragment),ro=d(),nt=a("p"),ea=s(`Note that executing the script requires enough CPU RAM to host the whole model in float16 precision (even if the biggest versions
come in several checkpoints they each contain a part of each weight of the model, so we need to load them all in RAM). For the 65B model, it\u2019s thus 130GB of RAM needed.`),so=d(),rt=a("ul"),I=a("li"),ta=s("The LLaMA tokenizer is based on "),be=a("a"),oa=s("sentencepiece"),aa=s(". One quirk of sentencepiece is that when decoding a sequence, if the first token is the start of the word (e.g. \u201CBanana\u201D), the tokenizer does not prepend the prefix space to the string. To have the tokenizer output the prefix space, set "),wt=a("code"),na=s("decode_with_prefix_space=True"),ra=s(" in the "),Tt=a("code"),sa=s("LlamaTokenizer"),ia=s(" object or in the tokenizer configuration."),io=d(),C=a("p"),la=s("This model was contributed by "),ke=a("a"),da=s("zphang"),ca=s(" with contributions from "),ye=a("a"),ma=s("BlackSamorez"),ha=s(". The code of the implementation in Hugging Face is based on GPT-NeoX "),Le=a("a"),pa=s("here"),fa=s(". The original code of the authors can be found "),we=a("a"),ua=s("here"),_a=s("."),lo=d(),j=a("h2"),Y=a("a"),$t=a("span"),_(Te.$$.fragment),ga=d(),zt=a("span"),va=s("LlamaConfig"),co=d(),A=a("div"),_($e.$$.fragment),ba=d(),ze=a("p"),ka=s("This is the configuration class to store the configuration of a "),st=a("a"),ya=s("LlamaModel"),La=s(`. It is used to instantiate an LLaMA
model according to the specified arguments, defining the model architecture. Instantiating a configuration with the
defaults will yield a similar configuration to that of the LLaMA-7B.`),wa=d(),W=a("p"),Ta=s("Configuration objects inherit from "),it=a("a"),$a=s("PretrainedConfig"),za=s(` and can be used to control the model outputs. Read the
documentation from `),lt=a("a"),Ma=s("PretrainedConfig"),Ea=s(" for more information."),Ca=d(),_(ee.$$.fragment),mo=d(),H=a("h2"),te=a("a"),Mt=a("span"),_(Me.$$.fragment),xa=d(),Et=a("span"),Aa=s("LlamaTokenizer"),ho=d(),z=a("div"),_(Ee.$$.fragment),Pa=d(),Ct=a("p"),Fa=s("Construct a Llama tokenizer. Based on byte-level Byte-Pair-Encoding."),qa=d(),dt=a("div"),_(Ce.$$.fragment),Ia=d(),oe=a("div"),_(xe.$$.fragment),Oa=d(),Ae=a("p"),Sa=s(`Retrieve sequence ids from a token list that has no special tokens added. This method is called when adding
special tokens using the tokenizer `),xt=a("code"),Na=s("prepare_for_model"),Da=s(" method."),Ba=d(),ae=a("div"),_(Pe.$$.fragment),ja=d(),At=a("p"),Wa=s(`Create a mask from the two sequences passed to be used in a sequence-pair classification task. T5 does not make
use of token type ids, therefore a list of zeros is returned.`),Ha=d(),ne=a("div"),_(Fe.$$.fragment),Ga=d(),Pt=a("p"),Ra=s("Save the vocabulary and special tokens file to a directory."),po=d(),G=a("h2"),re=a("a"),Ft=a("span"),_(qe.$$.fragment),Va=d(),qt=a("span"),Ua=s("LlamaModel"),fo=d(),M=a("div"),_(Ie.$$.fragment),Xa=d(),Oe=a("p"),Ja=s(`The bare LLaMA Model outputting raw hidden-states without any specific head on top.
This model inherits from `),ct=a("a"),Ka=s("PreTrainedModel"),Za=s(`. Check the superclass documentation for the generic methods the
library implements for all its model (such as downloading or saving, resizing the input embeddings, pruning heads
etc.)`),Qa=d(),Se=a("p"),Ya=s("This model is also a PyTorch "),Ne=a("a"),en=s("torch.nn.Module"),tn=s(` subclass.
Use it as a regular PyTorch Module and refer to the PyTorch documentation for all matter related to general usage
and behavior.`),on=d(),se=a("p"),an=s("Transformer decoder consisting of "),It=a("em"),nn=s("config.num_hidden_layers"),rn=s(" layers. Each layer is a "),Ot=a("code"),sn=s("LlamaDecoderLayer"),ln=d(),mt=a("div"),_(De.$$.fragment),uo=d(),R=a("h2"),ie=a("a"),St=a("span"),_(Be.$$.fragment),dn=d(),Nt=a("span"),cn=s("LlamaForCausalLM"),_o=d(),V=a("div"),_(je.$$.fragment),mn=d(),le=a("div"),_(We.$$.fragment),hn=d(),_(de.$$.fragment),go=d(),U=a("h2"),ce=a("a"),Dt=a("span"),_(He.$$.fragment),pn=d(),Bt=a("span"),fn=s("LlamaForSequenceClassification"),vo=d(),w=a("div"),_(Ge.$$.fragment),un=d(),jt=a("p"),_n=s("The LLaMa Model transformer with a sequence classification head on top (linear layer)."),gn=d(),ht=a("p"),pt=a("a"),vn=s("LlamaForSequenceClassification"),bn=s(` uses the last token in order to do the classification, as other causal models
(e.g. GPT-2) do.`),kn=d(),P=a("p"),yn=s(`Since it does classification on the last token, it requires to know the position of the last token. If a
`),Wt=a("code"),Ln=s("pad_token_id"),wn=s(` is defined in the configuration, it finds the last token that is not a padding token in each row. If
no `),Ht=a("code"),Tn=s("pad_token_id"),$n=s(` is defined, it simply takes the last value in each row of the batch. Since it cannot guess the
padding tokens when `),Gt=a("code"),zn=s("inputs_embeds"),Mn=s(" are passed instead of "),Rt=a("code"),En=s("input_ids"),Cn=s(`, it does the same (take the last value in
each row of the batch).`),xn=d(),Re=a("p"),An=s("This model inherits from "),ft=a("a"),Pn=s("PreTrainedModel"),Fn=s(`. Check the superclass documentation for the generic methods the
library implements for all its model (such as downloading or saving, resizing the input embeddings, pruning heads
etc.)`),qn=d(),Ve=a("p"),In=s("This model is also a PyTorch "),Ue=a("a"),On=s("torch.nn.Module"),Sn=s(` subclass.
Use it as a regular PyTorch Module and refer to the PyTorch documentation for all matter related to general usage
and behavior.`),Nn=d(),O=a("div"),_(Xe.$$.fragment),Dn=d(),X=a("p"),Bn=s("The "),ut=a("a"),jn=s("LlamaForSequenceClassification"),Wn=s(" forward method, overrides the "),Vt=a("code"),Hn=s("__call__"),Gn=s(" special method."),Rn=d(),_(me.$$.fragment),this.h()},l(e){const m=rs('[data-svelte="svelte-1phssyn"]',document.head);p=n(m,"META",{name:!0,content:!0}),m.forEach(o),T=c(e),f=n(e,"H1",{class:!0});var Je=r(f);L=n(Je,"A",{id:!0,class:!0,href:!0});var Ut=r(L);E=n(Ut,"SPAN",{});var Xt=r(E);g(u.$$.fragment,Xt),Xt.forEach(o),Ut.forEach(o),$=c(Je),K=n(Je,"SPAN",{});var Xn=r(K);Bo=i(Xn,"LLaMA"),Xn.forEach(o),Je.forEach(o),Kt=c(e),B=n(e,"H2",{class:!0});var ko=r(B);Z=n(ko,"A",{id:!0,class:!0,href:!0});var Jn=r(Z);bt=n(Jn,"SPAN",{});var Kn=r(bt);g(fe.$$.fragment,Kn),Kn.forEach(o),Jn.forEach(o),jo=c(ko),kt=n(ko,"SPAN",{});var Zn=r(kt);Wo=i(Zn,"Overview"),Zn.forEach(o),ko.forEach(o),Zt=c(e),Ze=n(e,"P",{});var Qn=r(Ze);Ho=i(Qn,"The LLaMA model was proposed in [LLaMA: Open and Efficient Foundation Language Models](LLaMA: Open and Efficient Foundation Language Models)  by Hugo Touvron, Thibaut Lavril, Gautier Izacard, Xavier Martinet, Marie-Anne Lachaux, Timoth\xE9e Lacroix, Baptiste Rozi\xE8re, Naman Goyal, Eric Hambro, Faisal Azhar, Aurelien Rodriguez, Armand Joulin, Edouard Grave, Guillaume Lample. It is a collection of foundation language models ranging from 7B to 65B parameters."),Qn.forEach(o),Qt=c(e),Qe=n(e,"P",{});var Yn=r(Qe);Go=i(Yn,"The abstract from the paper is the following:"),Yn.forEach(o),Yt=c(e),Ye=n(e,"P",{});var er=r(Ye);yt=n(er,"EM",{});var tr=r(yt);Ro=i(tr,"We introduce LLaMA, a collection of foundation language models ranging from 7B to 65B parameters. We train our models on trillions of tokens, and show that it is possible to train state-of-the-art models using publicly available datasets exclusively, without resorting to proprietary and inaccessible datasets. In particular, LLaMA-13B outperforms GPT-3 (175B) on most benchmarks, and LLaMA-65B is competitive with the best models, Chinchilla-70B and PaLM-540B. We release all our models to the research community."),tr.forEach(o),er.forEach(o),eo=c(e),et=n(e,"P",{});var or=r(et);Vo=i(or,"Tips:"),or.forEach(o),to=c(e),Q=n(e,"UL",{});var yo=r(Q);tt=n(yo,"LI",{});var Vn=r(tt);Uo=i(Vn,"Weights for the LLaMA models can be obtained from by filling out "),ue=n(Vn,"A",{href:!0,rel:!0});var ar=r(ue);Xo=i(ar,"this form"),ar.forEach(o),Vn.forEach(o),Jo=c(yo),_e=n(yo,"LI",{});var Lo=r(_e);Ko=i(Lo,"After downloading the weights, they will need to be converted to the Hugging Face Transformers format using the "),ot=n(Lo,"A",{href:!0});var nr=r(ot);Zo=i(nr,"conversion script"),nr.forEach(o),Qo=i(Lo,". The script can be called with the following (example) command:"),Lo.forEach(o),yo.forEach(o),oo=c(e),g(ge.$$.fragment,e),ao=c(e),at=n(e,"UL",{});var rr=r(at);Lt=n(rr,"LI",{});var sr=r(Lt);Yo=i(sr,"After conversion, the model and tokenizer can be loaded via:"),sr.forEach(o),rr.forEach(o),no=c(e),g(ve.$$.fragment,e),ro=c(e),nt=n(e,"P",{});var ir=r(nt);ea=i(ir,`Note that executing the script requires enough CPU RAM to host the whole model in float16 precision (even if the biggest versions
come in several checkpoints they each contain a part of each weight of the model, so we need to load them all in RAM). For the 65B model, it\u2019s thus 130GB of RAM needed.`),ir.forEach(o),so=c(e),rt=n(e,"UL",{});var lr=r(rt);I=n(lr,"LI",{});var he=r(I);ta=i(he,"The LLaMA tokenizer is based on "),be=n(he,"A",{href:!0,rel:!0});var dr=r(be);oa=i(dr,"sentencepiece"),dr.forEach(o),aa=i(he,". One quirk of sentencepiece is that when decoding a sequence, if the first token is the start of the word (e.g. \u201CBanana\u201D), the tokenizer does not prepend the prefix space to the string. To have the tokenizer output the prefix space, set "),wt=n(he,"CODE",{});var cr=r(wt);na=i(cr,"decode_with_prefix_space=True"),cr.forEach(o),ra=i(he," in the "),Tt=n(he,"CODE",{});var mr=r(Tt);sa=i(mr,"LlamaTokenizer"),mr.forEach(o),ia=i(he," object or in the tokenizer configuration."),he.forEach(o),lr.forEach(o),io=c(e),C=n(e,"P",{});var S=r(C);la=i(S,"This model was contributed by "),ke=n(S,"A",{href:!0,rel:!0});var hr=r(ke);da=i(hr,"zphang"),hr.forEach(o),ca=i(S," with contributions from "),ye=n(S,"A",{href:!0,rel:!0});var pr=r(ye);ma=i(pr,"BlackSamorez"),pr.forEach(o),ha=i(S,". The code of the implementation in Hugging Face is based on GPT-NeoX "),Le=n(S,"A",{href:!0,rel:!0});var fr=r(Le);pa=i(fr,"here"),fr.forEach(o),fa=i(S,". The original code of the authors can be found "),we=n(S,"A",{href:!0,rel:!0});var ur=r(we);ua=i(ur,"here"),ur.forEach(o),_a=i(S,"."),S.forEach(o),lo=c(e),j=n(e,"H2",{class:!0});var wo=r(j);Y=n(wo,"A",{id:!0,class:!0,href:!0});var _r=r(Y);$t=n(_r,"SPAN",{});var gr=r($t);g(Te.$$.fragment,gr),gr.forEach(o),_r.forEach(o),ga=c(wo),zt=n(wo,"SPAN",{});var vr=r(zt);va=i(vr,"LlamaConfig"),vr.forEach(o),wo.forEach(o),co=c(e),A=n(e,"DIV",{class:!0});var pe=r(A);g($e.$$.fragment,pe),ba=c(pe),ze=n(pe,"P",{});var To=r(ze);ka=i(To,"This is the configuration class to store the configuration of a "),st=n(To,"A",{href:!0});var br=r(st);ya=i(br,"LlamaModel"),br.forEach(o),La=i(To,`. It is used to instantiate an LLaMA
model according to the specified arguments, defining the model architecture. Instantiating a configuration with the
defaults will yield a similar configuration to that of the LLaMA-7B.`),To.forEach(o),wa=c(pe),W=n(pe,"P",{});var _t=r(W);Ta=i(_t,"Configuration objects inherit from "),it=n(_t,"A",{href:!0});var kr=r(it);$a=i(kr,"PretrainedConfig"),kr.forEach(o),za=i(_t,` and can be used to control the model outputs. Read the
documentation from `),lt=n(_t,"A",{href:!0});var yr=r(lt);Ma=i(yr,"PretrainedConfig"),yr.forEach(o),Ea=i(_t," for more information."),_t.forEach(o),Ca=c(pe),g(ee.$$.fragment,pe),pe.forEach(o),mo=c(e),H=n(e,"H2",{class:!0});var $o=r(H);te=n($o,"A",{id:!0,class:!0,href:!0});var Lr=r(te);Mt=n(Lr,"SPAN",{});var wr=r(Mt);g(Me.$$.fragment,wr),wr.forEach(o),Lr.forEach(o),xa=c($o),Et=n($o,"SPAN",{});var Tr=r(Et);Aa=i(Tr,"LlamaTokenizer"),Tr.forEach(o),$o.forEach(o),ho=c(e),z=n(e,"DIV",{class:!0});var F=r(z);g(Ee.$$.fragment,F),Pa=c(F),Ct=n(F,"P",{});var $r=r(Ct);Fa=i($r,"Construct a Llama tokenizer. Based on byte-level Byte-Pair-Encoding."),$r.forEach(o),qa=c(F),dt=n(F,"DIV",{class:!0});var zr=r(dt);g(Ce.$$.fragment,zr),zr.forEach(o),Ia=c(F),oe=n(F,"DIV",{class:!0});var zo=r(oe);g(xe.$$.fragment,zo),Oa=c(zo),Ae=n(zo,"P",{});var Mo=r(Ae);Sa=i(Mo,`Retrieve sequence ids from a token list that has no special tokens added. This method is called when adding
special tokens using the tokenizer `),xt=n(Mo,"CODE",{});var Mr=r(xt);Na=i(Mr,"prepare_for_model"),Mr.forEach(o),Da=i(Mo," method."),Mo.forEach(o),zo.forEach(o),Ba=c(F),ae=n(F,"DIV",{class:!0});var Eo=r(ae);g(Pe.$$.fragment,Eo),ja=c(Eo),At=n(Eo,"P",{});var Er=r(At);Wa=i(Er,`Create a mask from the two sequences passed to be used in a sequence-pair classification task. T5 does not make
use of token type ids, therefore a list of zeros is returned.`),Er.forEach(o),Eo.forEach(o),Ha=c(F),ne=n(F,"DIV",{class:!0});var Co=r(ne);g(Fe.$$.fragment,Co),Ga=c(Co),Pt=n(Co,"P",{});var Cr=r(Pt);Ra=i(Cr,"Save the vocabulary and special tokens file to a directory."),Cr.forEach(o),Co.forEach(o),F.forEach(o),po=c(e),G=n(e,"H2",{class:!0});var xo=r(G);re=n(xo,"A",{id:!0,class:!0,href:!0});var xr=r(re);Ft=n(xr,"SPAN",{});var Ar=r(Ft);g(qe.$$.fragment,Ar),Ar.forEach(o),xr.forEach(o),Va=c(xo),qt=n(xo,"SPAN",{});var Pr=r(qt);Ua=i(Pr,"LlamaModel"),Pr.forEach(o),xo.forEach(o),fo=c(e),M=n(e,"DIV",{class:!0});var N=r(M);g(Ie.$$.fragment,N),Xa=c(N),Oe=n(N,"P",{});var Ao=r(Oe);Ja=i(Ao,`The bare LLaMA Model outputting raw hidden-states without any specific head on top.
This model inherits from `),ct=n(Ao,"A",{href:!0});var Fr=r(ct);Ka=i(Fr,"PreTrainedModel"),Fr.forEach(o),Za=i(Ao,`. Check the superclass documentation for the generic methods the
library implements for all its model (such as downloading or saving, resizing the input embeddings, pruning heads
etc.)`),Ao.forEach(o),Qa=c(N),Se=n(N,"P",{});var Po=r(Se);Ya=i(Po,"This model is also a PyTorch "),Ne=n(Po,"A",{href:!0,rel:!0});var qr=r(Ne);en=i(qr,"torch.nn.Module"),qr.forEach(o),tn=i(Po,` subclass.
Use it as a regular PyTorch Module and refer to the PyTorch documentation for all matter related to general usage
and behavior.`),Po.forEach(o),on=c(N),se=n(N,"P",{});var Jt=r(se);an=i(Jt,"Transformer decoder consisting of "),It=n(Jt,"EM",{});var Ir=r(It);nn=i(Ir,"config.num_hidden_layers"),Ir.forEach(o),rn=i(Jt," layers. Each layer is a "),Ot=n(Jt,"CODE",{});var Or=r(Ot);sn=i(Or,"LlamaDecoderLayer"),Or.forEach(o),Jt.forEach(o),ln=c(N),mt=n(N,"DIV",{class:!0});var Sr=r(mt);g(De.$$.fragment,Sr),Sr.forEach(o),N.forEach(o),uo=c(e),R=n(e,"H2",{class:!0});var Fo=r(R);ie=n(Fo,"A",{id:!0,class:!0,href:!0});var Nr=r(ie);St=n(Nr,"SPAN",{});var Dr=r(St);g(Be.$$.fragment,Dr),Dr.forEach(o),Nr.forEach(o),dn=c(Fo),Nt=n(Fo,"SPAN",{});var Br=r(Nt);cn=i(Br,"LlamaForCausalLM"),Br.forEach(o),Fo.forEach(o),_o=c(e),V=n(e,"DIV",{class:!0});var qo=r(V);g(je.$$.fragment,qo),mn=c(qo),le=n(qo,"DIV",{class:!0});var Io=r(le);g(We.$$.fragment,Io),hn=c(Io),g(de.$$.fragment,Io),Io.forEach(o),qo.forEach(o),go=c(e),U=n(e,"H2",{class:!0});var Oo=r(U);ce=n(Oo,"A",{id:!0,class:!0,href:!0});var jr=r(ce);Dt=n(jr,"SPAN",{});var Wr=r(Dt);g(He.$$.fragment,Wr),Wr.forEach(o),jr.forEach(o),pn=c(Oo),Bt=n(Oo,"SPAN",{});var Hr=r(Bt);fn=i(Hr,"LlamaForSequenceClassification"),Hr.forEach(o),Oo.forEach(o),vo=c(e),w=n(e,"DIV",{class:!0});var x=r(w);g(Ge.$$.fragment,x),un=c(x),jt=n(x,"P",{});var Gr=r(jt);_n=i(Gr,"The LLaMa Model transformer with a sequence classification head on top (linear layer)."),Gr.forEach(o),gn=c(x),ht=n(x,"P",{});var Un=r(ht);pt=n(Un,"A",{href:!0});var Rr=r(pt);vn=i(Rr,"LlamaForSequenceClassification"),Rr.forEach(o),bn=i(Un,` uses the last token in order to do the classification, as other causal models
(e.g. GPT-2) do.`),Un.forEach(o),kn=c(x),P=n(x,"P",{});var D=r(P);yn=i(D,`Since it does classification on the last token, it requires to know the position of the last token. If a
`),Wt=n(D,"CODE",{});var Vr=r(Wt);Ln=i(Vr,"pad_token_id"),Vr.forEach(o),wn=i(D,` is defined in the configuration, it finds the last token that is not a padding token in each row. If
no `),Ht=n(D,"CODE",{});var Ur=r(Ht);Tn=i(Ur,"pad_token_id"),Ur.forEach(o),$n=i(D,` is defined, it simply takes the last value in each row of the batch. Since it cannot guess the
padding tokens when `),Gt=n(D,"CODE",{});var Xr=r(Gt);zn=i(Xr,"inputs_embeds"),Xr.forEach(o),Mn=i(D," are passed instead of "),Rt=n(D,"CODE",{});var Jr=r(Rt);En=i(Jr,"input_ids"),Jr.forEach(o),Cn=i(D,`, it does the same (take the last value in
each row of the batch).`),D.forEach(o),xn=c(x),Re=n(x,"P",{});var So=r(Re);An=i(So,"This model inherits from "),ft=n(So,"A",{href:!0});var Kr=r(ft);Pn=i(Kr,"PreTrainedModel"),Kr.forEach(o),Fn=i(So,`. Check the superclass documentation for the generic methods the
library implements for all its model (such as downloading or saving, resizing the input embeddings, pruning heads
etc.)`),So.forEach(o),qn=c(x),Ve=n(x,"P",{});var No=r(Ve);In=i(No,"This model is also a PyTorch "),Ue=n(No,"A",{href:!0,rel:!0});var Zr=r(Ue);On=i(Zr,"torch.nn.Module"),Zr.forEach(o),Sn=i(No,` subclass.
Use it as a regular PyTorch Module and refer to the PyTorch documentation for all matter related to general usage
and behavior.`),No.forEach(o),Nn=c(x),O=n(x,"DIV",{class:!0});var gt=r(O);g(Xe.$$.fragment,gt),Dn=c(gt),X=n(gt,"P",{});var vt=r(X);Bn=i(vt,"The "),ut=n(vt,"A",{href:!0});var Qr=r(ut);jn=i(Qr,"LlamaForSequenceClassification"),Qr.forEach(o),Wn=i(vt," forward method, overrides the "),Vt=n(vt,"CODE",{});var Yr=r(Vt);Hn=i(Yr,"__call__"),Yr.forEach(o),Gn=i(vt," special method."),vt.forEach(o),Rn=c(gt),g(me.$$.fragment,gt),gt.forEach(o),x.forEach(o),this.h()},h(){l(p,"name","hf:doc:metadata"),l(p,"content",JSON.stringify(hs)),l(L,"id","llama"),l(L,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),l(L,"href","#llama"),l(f,"class","relative group"),l(Z,"id","overview"),l(Z,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),l(Z,"href","#overview"),l(B,"class","relative group"),l(ue,"href","https://docs.google.com/forms/d/e/1FAIpQLSfqNECQnMkycAp2jP4Z9TFX0cGR4uf7b_fBxjY_OjhJILlKGA/viewform?usp=send_form"),l(ue,"rel","nofollow"),l(ot,"href","/src/transformers/models/llama/convert_llama_weights_to_hf.py"),l(be,"href","https://github.com/google/sentencepiece"),l(be,"rel","nofollow"),l(ke,"href","https://huggingface.co/zphang"),l(ke,"rel","nofollow"),l(ye,"href","https://huggingface.co/BlackSamorez"),l(ye,"rel","nofollow"),l(Le,"href","https://github.com/EleutherAI/gpt-neox"),l(Le,"rel","nofollow"),l(we,"href","https://github.com/facebookresearch/llama"),l(we,"rel","nofollow"),l(Y,"id","transformers.LlamaConfig"),l(Y,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),l(Y,"href","#transformers.LlamaConfig"),l(j,"class","relative group"),l(st,"href","/docs/transformers/pr_22317/en/model_doc/llama#transformers.LlamaModel"),l(it,"href","/docs/transformers/pr_22317/en/main_classes/configuration#transformers.PretrainedConfig"),l(lt,"href","/docs/transformers/pr_22317/en/main_classes/configuration#transformers.PretrainedConfig"),l(A,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),l(te,"id","transformers.LlamaTokenizer"),l(te,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),l(te,"href","#transformers.LlamaTokenizer"),l(H,"class","relative group"),l(dt,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),l(oe,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),l(ae,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),l(ne,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),l(z,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),l(re,"id","transformers.LlamaModel"),l(re,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),l(re,"href","#transformers.LlamaModel"),l(G,"class","relative group"),l(ct,"href","/docs/transformers/pr_22317/en/main_classes/model#transformers.PreTrainedModel"),l(Ne,"href","https://pytorch.org/docs/stable/nn.html#torch.nn.Module"),l(Ne,"rel","nofollow"),l(mt,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),l(M,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),l(ie,"id","transformers.LlamaForCausalLM"),l(ie,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),l(ie,"href","#transformers.LlamaForCausalLM"),l(R,"class","relative group"),l(le,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),l(V,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),l(ce,"id","transformers.LlamaForSequenceClassification"),l(ce,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),l(ce,"href","#transformers.LlamaForSequenceClassification"),l(U,"class","relative group"),l(pt,"href","/docs/transformers/pr_22317/en/model_doc/llama#transformers.LlamaForSequenceClassification"),l(ft,"href","/docs/transformers/pr_22317/en/main_classes/model#transformers.PreTrainedModel"),l(Ue,"href","https://pytorch.org/docs/stable/nn.html#torch.nn.Module"),l(Ue,"rel","nofollow"),l(ut,"href","/docs/transformers/pr_22317/en/model_doc/llama#transformers.LlamaForSequenceClassification"),l(O,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),l(w,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8")},m(e,m){t(document.head,p),h(e,T,m),h(e,f,m),t(f,L),t(L,E),v(u,E,null),t(f,$),t(f,K),t(K,Bo),h(e,Kt,m),h(e,B,m),t(B,Z),t(Z,bt),v(fe,bt,null),t(B,jo),t(B,kt),t(kt,Wo),h(e,Zt,m),h(e,Ze,m),t(Ze,Ho),h(e,Qt,m),h(e,Qe,m),t(Qe,Go),h(e,Yt,m),h(e,Ye,m),t(Ye,yt),t(yt,Ro),h(e,eo,m),h(e,et,m),t(et,Vo),h(e,to,m),h(e,Q,m),t(Q,tt),t(tt,Uo),t(tt,ue),t(ue,Xo),t(Q,Jo),t(Q,_e),t(_e,Ko),t(_e,ot),t(ot,Zo),t(_e,Qo),h(e,oo,m),v(ge,e,m),h(e,ao,m),h(e,at,m),t(at,Lt),t(Lt,Yo),h(e,no,m),v(ve,e,m),h(e,ro,m),h(e,nt,m),t(nt,ea),h(e,so,m),h(e,rt,m),t(rt,I),t(I,ta),t(I,be),t(be,oa),t(I,aa),t(I,wt),t(wt,na),t(I,ra),t(I,Tt),t(Tt,sa),t(I,ia),h(e,io,m),h(e,C,m),t(C,la),t(C,ke),t(ke,da),t(C,ca),t(C,ye),t(ye,ma),t(C,ha),t(C,Le),t(Le,pa),t(C,fa),t(C,we),t(we,ua),t(C,_a),h(e,lo,m),h(e,j,m),t(j,Y),t(Y,$t),v(Te,$t,null),t(j,ga),t(j,zt),t(zt,va),h(e,co,m),h(e,A,m),v($e,A,null),t(A,ba),t(A,ze),t(ze,ka),t(ze,st),t(st,ya),t(ze,La),t(A,wa),t(A,W),t(W,Ta),t(W,it),t(it,$a),t(W,za),t(W,lt),t(lt,Ma),t(W,Ea),t(A,Ca),v(ee,A,null),h(e,mo,m),h(e,H,m),t(H,te),t(te,Mt),v(Me,Mt,null),t(H,xa),t(H,Et),t(Et,Aa),h(e,ho,m),h(e,z,m),v(Ee,z,null),t(z,Pa),t(z,Ct),t(Ct,Fa),t(z,qa),t(z,dt),v(Ce,dt,null),t(z,Ia),t(z,oe),v(xe,oe,null),t(oe,Oa),t(oe,Ae),t(Ae,Sa),t(Ae,xt),t(xt,Na),t(Ae,Da),t(z,Ba),t(z,ae),v(Pe,ae,null),t(ae,ja),t(ae,At),t(At,Wa),t(z,Ha),t(z,ne),v(Fe,ne,null),t(ne,Ga),t(ne,Pt),t(Pt,Ra),h(e,po,m),h(e,G,m),t(G,re),t(re,Ft),v(qe,Ft,null),t(G,Va),t(G,qt),t(qt,Ua),h(e,fo,m),h(e,M,m),v(Ie,M,null),t(M,Xa),t(M,Oe),t(Oe,Ja),t(Oe,ct),t(ct,Ka),t(Oe,Za),t(M,Qa),t(M,Se),t(Se,Ya),t(Se,Ne),t(Ne,en),t(Se,tn),t(M,on),t(M,se),t(se,an),t(se,It),t(It,nn),t(se,rn),t(se,Ot),t(Ot,sn),t(M,ln),t(M,mt),v(De,mt,null),h(e,uo,m),h(e,R,m),t(R,ie),t(ie,St),v(Be,St,null),t(R,dn),t(R,Nt),t(Nt,cn),h(e,_o,m),h(e,V,m),v(je,V,null),t(V,mn),t(V,le),v(We,le,null),t(le,hn),v(de,le,null),h(e,go,m),h(e,U,m),t(U,ce),t(ce,Dt),v(He,Dt,null),t(U,pn),t(U,Bt),t(Bt,fn),h(e,vo,m),h(e,w,m),v(Ge,w,null),t(w,un),t(w,jt),t(jt,_n),t(w,gn),t(w,ht),t(ht,pt),t(pt,vn),t(ht,bn),t(w,kn),t(w,P),t(P,yn),t(P,Wt),t(Wt,Ln),t(P,wn),t(P,Ht),t(Ht,Tn),t(P,$n),t(P,Gt),t(Gt,zn),t(P,Mn),t(P,Rt),t(Rt,En),t(P,Cn),t(w,xn),t(w,Re),t(Re,An),t(Re,ft),t(ft,Pn),t(Re,Fn),t(w,qn),t(w,Ve),t(Ve,In),t(Ve,Ue),t(Ue,On),t(Ve,Sn),t(w,Nn),t(w,O),v(Xe,O,null),t(O,Dn),t(O,X),t(X,Bn),t(X,ut),t(ut,jn),t(X,Wn),t(X,Vt),t(Vt,Hn),t(X,Gn),t(O,Rn),v(me,O,null),bo=!0},p(e,[m]){const Je={};m&2&&(Je.$$scope={dirty:m,ctx:e}),ee.$set(Je);const Ut={};m&2&&(Ut.$$scope={dirty:m,ctx:e}),de.$set(Ut);const Xt={};m&2&&(Xt.$$scope={dirty:m,ctx:e}),me.$set(Xt)},i(e){bo||(b(u.$$.fragment,e),b(fe.$$.fragment,e),b(ge.$$.fragment,e),b(ve.$$.fragment,e),b(Te.$$.fragment,e),b($e.$$.fragment,e),b(ee.$$.fragment,e),b(Me.$$.fragment,e),b(Ee.$$.fragment,e),b(Ce.$$.fragment,e),b(xe.$$.fragment,e),b(Pe.$$.fragment,e),b(Fe.$$.fragment,e),b(qe.$$.fragment,e),b(Ie.$$.fragment,e),b(De.$$.fragment,e),b(Be.$$.fragment,e),b(je.$$.fragment,e),b(We.$$.fragment,e),b(de.$$.fragment,e),b(He.$$.fragment,e),b(Ge.$$.fragment,e),b(Xe.$$.fragment,e),b(me.$$.fragment,e),bo=!0)},o(e){k(u.$$.fragment,e),k(fe.$$.fragment,e),k(ge.$$.fragment,e),k(ve.$$.fragment,e),k(Te.$$.fragment,e),k($e.$$.fragment,e),k(ee.$$.fragment,e),k(Me.$$.fragment,e),k(Ee.$$.fragment,e),k(Ce.$$.fragment,e),k(xe.$$.fragment,e),k(Pe.$$.fragment,e),k(Fe.$$.fragment,e),k(qe.$$.fragment,e),k(Ie.$$.fragment,e),k(De.$$.fragment,e),k(Be.$$.fragment,e),k(je.$$.fragment,e),k(We.$$.fragment,e),k(de.$$.fragment,e),k(He.$$.fragment,e),k(Ge.$$.fragment,e),k(Xe.$$.fragment,e),k(me.$$.fragment,e),bo=!1},d(e){o(p),e&&o(T),e&&o(f),y(u),e&&o(Kt),e&&o(B),y(fe),e&&o(Zt),e&&o(Ze),e&&o(Qt),e&&o(Qe),e&&o(Yt),e&&o(Ye),e&&o(eo),e&&o(et),e&&o(to),e&&o(Q),e&&o(oo),y(ge,e),e&&o(ao),e&&o(at),e&&o(no),y(ve,e),e&&o(ro),e&&o(nt),e&&o(so),e&&o(rt),e&&o(io),e&&o(C),e&&o(lo),e&&o(j),y(Te),e&&o(co),e&&o(A),y($e),y(ee),e&&o(mo),e&&o(H),y(Me),e&&o(ho),e&&o(z),y(Ee),y(Ce),y(xe),y(Pe),y(Fe),e&&o(po),e&&o(G),y(qe),e&&o(fo),e&&o(M),y(Ie),y(De),e&&o(uo),e&&o(R),y(Be),e&&o(_o),e&&o(V),y(je),y(We),y(de),e&&o(go),e&&o(U),y(He),e&&o(vo),e&&o(w),y(Ge),y(Xe),y(me)}}}const hs={local:"llama",sections:[{local:"overview",title:"Overview"},{local:"transformers.LlamaConfig",title:"LlamaConfig"},{local:"transformers.LlamaTokenizer",title:"LlamaTokenizer"},{local:"transformers.LlamaModel",title:"LlamaModel"},{local:"transformers.LlamaForCausalLM",title:"LlamaForCausalLM"},{local:"transformers.LlamaForSequenceClassification",title:"LlamaForSequenceClassification"}],title:"LLaMA"};function ps(J){return ss(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class ks extends os{constructor(p){super();as(this,p,ps,ms,ns,{})}}export{ks as default,hs as metadata};
